// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.bankbalance;

import java.math.BigDecimal;

import net.sf.chex4j.Contract;
import net.sf.chex4j.Post;
import net.sf.chex4j.Pre;

@Contract
public interface IBankAccount {

	@Post("$_.doubleValue() >= 0.0d")
	public abstract BigDecimal getBalance();

	@Pre("amount.doubleValue() >= 0.0d")
	@Post("$_.doubleValue() == this.balance.doubleValue()")
	public abstract BigDecimal deposit(BigDecimal amount);

	@Pre("amount.doubleValue() >= 0.0d && this.balance.doubleValue() - amount.doubleValue() >= 0.0d")
	public abstract BigDecimal withdraw(BigDecimal amount);

}