// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.bankbalance;

import java.math.BigDecimal;

import net.sf.chex4j.Contract;
import net.sf.chex4j.Post;
import net.sf.chex4j.Pre;

@Contract
public interface ITaxable {
	/**
	 * @param percent The tax rate
	 * @return The balance after applying tax
	 */
	@Pre("percent < 100")
	@Post("$_.doubleValue() > 0.0d")
	public BigDecimal tax(int percent );
}
