// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.bankbalance;

import java.math.BigDecimal;

import net.sf.chex4j.Contract;
import net.sf.chex4j.Post;
import net.sf.chex4j.Pre;

@Contract
public class PrivateLogicChexBankAccount extends SimplePublicBankAccount {
	
	public boolean preLogicCalled = false;
	public boolean postLogicCalled = false;

	public PrivateLogicChexBankAccount(BigDecimal amount) {
		super(amount);
	}

	@Override
	@Pre("preLogic($$)")
	@Post("postLogic($$)")
	public BigDecimal withdraw(BigDecimal amount) {
		this.balance = this.balance.subtract(amount);
		return this.balance;
	}
	
	@SuppressWarnings("unused")
	private boolean preLogic( BigDecimal amount ){
		this.preLogicCalled = true;
		return amount.doubleValue() >= 1.0d;
	}
	
	@SuppressWarnings("unused")
	private boolean postLogic( BigDecimal amount){
		this.postLogicCalled = true;
		return this.balance.doubleValue() >= 5.0d;
	}

}
