// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j.bankbalance;

import java.math.BigDecimal;

import net.sf.chex4j.Contract;
import net.sf.chex4j.Post;
import net.sf.chex4j.Pre;

@Contract
//@Invar("$this.balance > = 0.0")
/*package*/ class SimplePackageProtectedBankAccount {

	/**
	 * This field is public to allow you to corrupt the invariants of the class. 
	 * Clearly if you want to protect the invariants of a class you need to 
	 * encapsulate its contents. 
	 */
	/*package*/ BigDecimal balance = new BigDecimal(0);

	@Post("$_.doubleValue() >= 0.0d")
	/*package*/ BigDecimal getBalance(){
		return this.balance;
	}

	@Pre("amount.doubleValue() >= 0.0d")
	//@Post("this.balance.doubleValue() == chex4jOld.get(this.balance).doubleValue()+amount.doubleValue() && $_.doubleValue() == this.balance.doubleValue()")
	@Post("$_.doubleValue() == this.balance.doubleValue()")
	/*package*/ BigDecimal deposit(BigDecimal amount) {
		this.balance = this.balance.add(amount);
		return this.balance;
	}

	@Pre("amount.doubleValue() >= 0.0d && this.balance.doubleValue() - amount.doubleValue() >= 0.0d")
//	@Post("$this.balance == $old($this.balance)-amount && $return == $this.balance")
	/*package*/ BigDecimal withdraw(BigDecimal amount){
		this.balance = this.balance.subtract(amount);
		return this.balance;
	}

}
